pipeline {
	agent any
    environment {
        VERSION = 'Product-${BUILD_NUMBER}'
    }
    stages {
        stage ('Clean workspace') {
            steps {
                sh 'git clean -xffd'
            }
        }


        stage('Build du Projet') { 
		 agent {docker 'maven:3.8.3-openjdk-17'}
            steps {
			
                sh '''mvn clean install -DskipTests 
                cd target
                ls

                '''
				stash includes: 'target/*.jar', name: 'targetfiles'
				
            }
        }

        
        // Sonarqube Analyse 
        stage('Sonarqube analysis ') {
        tools
         {
            maven 'maven'  
         }     
          steps {
            withSonarQubeEnv(installationName:'sonar') {
              sh '''./mvmw clean org.sonarsource.scanner.maven:sonar-maven-plugin:3.9.0.2155:sonar'''
              
            }
          }
        }


        //Build and Upload Image Docker
        stage('Build and Upload Image docker') {
            steps { 
                unstash 'targetfiles'
			   
			   script {
			            sh 'docker login -u mrw1234 -p sesame123' 
						sh 'docker build -t product .'
                        sh 'docker tag product mrw1234/product'
                        sh 'docker push mrw1234/product'
                    }
            }
        }

         // nexus
        stage('Nexus') {
           
            steps {
                unstash 'targetfiles'
                nexusArtifactUploader artifacts: [[artifactId: 'Product', classifier: '', file: 'target/product-service-1.0-SNAPSHOT.jar', type: 'jar']], credentialsId: 'nexus_credentials', groupId: 'backend', nexusUrl: '192.168.115.128:8081', nexusVersion: 'nexus3', protocol: 'http', repository: 'Product/',version: VERSION
            }
        }


        stage('Apply Kubernetes File') {
        steps {
          withKubeCredentials(kubectlCredentials: [[caCertificate: '', clusterName: 'default', contextName: '', credentialsId: 'kubernetes', namespace: 'default', serverUrl: 'https://192.168.115.128:6443']]) 

         {
               sh 'curl -LO "https://storage.googleapis.com/kubernetes-release/release/v1.20.5/bin/linux/amd64/kubectl"'
               sh 'chmod u+x ./kubectl'
               sh './kubectl apply -f product.yml'
               echo 'service ok'
         }
            }
  } 


    
}
}
		


